// ===========================================================================
//	CAppearanceDemoApp.cp	1997-2002 Metrowerks Corporation.  All rights reserved.
// ===========================================================================
//	Original Author: John C. Daub

#include "CAppearanceDemoApp.h"

#include <LGrowZone.h>
#include <LWindow.h>
#include <PP_Messages.h>
#include <PP_Resources.h>
#include <PP_KeyCodes.h>
#include <UDesktop.h>
#include <UDrawingState.h>
#include <UMemoryMgr.h>
#include <URegistrar.h>
#include <UScrap.h>
#include <LMLTEPane.h>
#include <UDesktop.h>

#include <UControlRegistry.h>
#include <UGraphicUtils.h>
#include <UEnvironment.h>
#include <LString.h>
#include <UWindows.h>
#include <LUndoer.h>
#include <UReanimator.h>
#include <LTextEditView.h>
#include <LTabGroup.h>
#include <LPicture.h>
#include <LWindowToolbar.h>
#include <LToolbarView.h>

#include <LDataBrowser.h>
#include <LDataBrowserImp.h>

#include "CDemoDataBrowser.h"
#include "CDemoDataItem.h"


#include <LStaticText.h>
#include <LProgressBar.h>
#include <LLittleArrows.h>
#include <LSlider.h>
#include <LScrollBar.h>
#include <LCheckBox.h>
#include <LScrollerView.h>
#include <LTextGroupBox.h>
#include <LCheckBoxGroupBox.h>
#include <LPopupGroupBox.h>
#include <LImageWell.h>
#include <LPictureControl.h>
#include <LMultiPanelView.h>
#include <LPopupButton.h>
#include <LDisclosureTriangle.h>
#include <LPageController.h>
#include <UModalDialogs.h>
#include <LWindowDrawer.h>
#include <LRadioGroup.h>
#include "LWindowSheet.h"
#include "LWindowDrawer.h"
#include "LEditTextSheet.h"
#include "LPopupButtonSheet.h"
#include "GLPane.h"
#include "ABalloon.h"
#include "LTextGroupBoxSheet.h"
#include "GLPaneShape.h"
#include "GLPaneShape_CART.h"
#include "GLPaneShape_PARAM.h"
#include "bigDonutSlider.h"

#include "Graph2D.h"
#include "Graph2D_CART.h"
#include "Graph2D_PARAM.h"
#include "Graph2D_INE.h"
#include "Graph2D_POL.h"

#include "LScriptMenuAttachment.h"

#include "bigDonutSlider.h"
#include "Dial.h"

#include <LMenuBar.h>

#include <LCMAttachment.h>
#include "CCMWindowAttachment.h"
#include <UCMMUtils.h>

#include "CURLCaption.h"
#include "CCMURLAttachment.h"

#include <Appearance.h>
#include <Sound.h>


// our constants

const	CommandT	cmd_CopyURLToClipboard		= FOUR_CHAR_CODE('Cu2C');
const	CommandT	cmd_Beep						= FOUR_CHAR_CODE('BEEP');
const	CommandT	cmd_BeepTwice					= FOUR_CHAR_CODE('BEP2');

const	ResIDT		MBAR_Appearance					= MBAR_Initial;
const	ResIDT		MBAR_Mercutio					= 129;

const	ResIDT		PPob_DemoWindow					= 128;
const	ResIDT		PPob_FloatingWindow				= 129;
const	ResIDT		PPob_FirstMultiPanelView		= 1000;
const	ResIDT		PPob_ScrollingView				= 1500;
const	ResIDT		PPob_Dialog						= 2000;

const	ResIDT		MENU_AMPopup					= 10000;
const	ResIDT		MENU_GAPopup					= 10001;

const	CommandT	cmd_NewGrayWindow				= FOUR_CHAR_CODE('Gray');
const	CommandT	cmd_NewFloatingWindow			= FOUR_CHAR_CODE('Flot');
const	CommandT	cmd_ToolBarWindow			= FOUR_CHAR_CODE('Tool');
const	CommandT	cmd_Dialog						= FOUR_CHAR_CODE('Dlog');

const	LStr255		str_AMWindowTitle				= StringLiteral_("Appearance Manager");
const	LStr255		str_GAWindowTitle				= StringLiteral_("Grayscale Window");
const	LStr255		str_ToolBarWindowTitle	= StringLiteral_("Toolbar Window");

const	PaneIDT		item_AMGACaption				= FOUR_CHAR_CODE('AMGA');
const	PaneIDT		item_DeterminantPBar			= FOUR_CHAR_CODE('PBAd');
const	PaneIDT		item_TrackingCaption			= FOUR_CHAR_CODE('Tcap');
const	PaneIDT		item_LittleArrows				= FOUR_CHAR_CODE('LARR');
const	PaneIDT		item_Slider						= FOUR_CHAR_CODE('SLID');
const	PaneIDT		item_ScrollBar					= FOUR_CHAR_CODE('SBAR');
const	PaneIDT		item_TrackingCheckBox			= FOUR_CHAR_CODE('TRCK');
const	PaneIDT		item_ScrollerView				= FOUR_CHAR_CODE('SCLV');
const	PaneIDT		item_LiveGroupBox				= FOUR_CHAR_CODE('LVBX');
const	PaneIDT		item_BroadcastValueCaption		= FOUR_CHAR_CODE('BrVl');
const	PaneIDT		item_CheckBoxGroupBox			= FOUR_CHAR_CODE('CBGB');
const	PaneIDT		item_PopupGroupBox				= FOUR_CHAR_CODE('PGBX');
const	PaneIDT		item_ImageWell					= FOUR_CHAR_CODE('IWEL');
const	PaneIDT		item_PictureControl				= FOUR_CHAR_CODE('PICD');
const	PaneIDT		item_MultiPanelView				= FOUR_CHAR_CODE('MPVW');
const	PaneIDT		item_PopupButton				= FOUR_CHAR_CODE('POPB');
const	PaneIDT		item_DisclosureTriangle			= FOUR_CHAR_CODE('DTRI');

const	PaneIDT		item_DialogMainPanelView		= FOUR_CHAR_CODE('MPV2');
const	PaneIDT		item_DialogSecondPanelView		= FOUR_CHAR_CODE('MPV3');
const	PaneIDT		item_DialogPageController		= FOUR_CHAR_CODE('PCTL');
const	PaneIDT		item_DialogURLCaption			= FOUR_CHAR_CODE('URLc');
const	MessageT	msg_PageController				= item_DialogPageController;
const	SInt16		index_SundryPanel				= 3;

const	MessageT	msg_DeterminantPBar				= item_DeterminantPBar;
const	MessageT	msg_LittleArrows				= item_LittleArrows;
const	MessageT	msg_Slider						= item_Slider;
const	MessageT	msg_ScrollBar					= item_ScrollBar;
const	MessageT	msg_DoTracking					= item_TrackingCheckBox;
const	MessageT	msg_CheckBoxGroupBox			= item_CheckBoxGroupBox;
const	MessageT	msg_PopupGroupBox				= item_PopupGroupBox;
const	MessageT	msg_ImageWell					= item_ImageWell;
const	MessageT	msg_PictureControl				= item_PictureControl;
const	MessageT	msg_PopupButton					= item_PopupButton;
const	MessageT	msg_DisclosureTriangle			= item_DisclosureTriangle;

const	SInt32		kDiscloseAmount					= 272; // pixels of height


// ===========================================================================
//		 Main Program
// ===========================================================================

int main()
{
	SetDebugThrow_(debugAction_Alert);
	SetDebugSignal_(debugAction_Alert);

	InitializeHeap(3);
	UQDGlobals::InitializeToolbox();

	UCMMUtils::Initialize();				// Initialize Contextual Menu support
	
	new LGrowZone(20000);
	
	CAppearanceDemoApp	theApp;
	theApp.Run();
	
	// puis on purge les LMLTE
	LMLTEPane::Terminate();
	
	return 0;
}


// ---------------------------------------------------------------------------
//		 CAppearanceDemoApp
// ---------------------------------------------------------------------------
//	Constructor

CAppearanceDemoApp::CAppearanceDemoApp()
{
	// permet d'activer l'antialiasing
	::QDSwapTextFlags(kQDSupportedFlags);
	
		// Register ourselves with the Appearance Manager
	if (UEnvironment::HasFeature(env_HasAppearance)) {
		::RegisterAppearanceClient();
	}

	// Register the Appearance Manager/GA classes
	
	UControlRegistry::RegisterClasses();
	
	// other stuff
	RegisterClass_(LRadioGroup);
	RegisterClass_(LWindowSheet);
	RegisterClass_(LTabGroup);
	RegisterClass_(LView);
	RegisterClass_(LPicture);
	RegisterClass_(LWindow);
	RegisterClass_(LUndoer);
	RegisterClass_(LTextEditView);
	RegisterClass_(LPageController);
	RegisterClass_(LWindowThemeAttachment);
	RegisterClass_(LCMAttachment);
	
	RegisterClass_(CCMWindowAttachment);
	RegisterClass_(CURLCaption);
	RegisterClass_(CCMURLAttachment);
	RegisterClass_(LWindowToolbar);
	RegisterClass_(LToolbarView);
	RegisterClass_(LWindowDrawer);
	
	RegisterClass_(GLPane);
	RegisterClass_(GLPaneShape);
	RegisterClass_(GLPaneShape_PARAM);
	RegisterClass_(GLPaneShape_CART);
	RegisterClass_(LWindowToolbar);
	RegisterClass_(LToolbarView);
	RegisterClass_(Graph2D);
	RegisterClass_(Graph2D_CART);
	RegisterClass_(Graph2D_PARAM);
	RegisterClass_(Graph2D_INE);
	RegisterClass_(Graph2D_POL);
	
	RegisterClass_(LDataBrowser);
	RegisterClassID_(LDataBrowserImp, LDataBrowser::imp_class_ID);
	RegisterClass_(CDemoDataBrowser);
	RegisterClass_(Dial);
	RegisterClass_(bigDonutSlider);
	
	RegisterClass_ (LMLTEPane);
	
	LMLTEPane::Initialize (NULL,NULL,NULL,0,kTXNWantMoviesMask | kTXNWantSoundMask | kTXNWantGraphicsMask);
	
	// set up our governor for the determinant LProgressBar
	
	mLastTick = ::TickCount();
	
	AddAttachment(new LCMAttachment);
}

void CAppearanceDemoApp::Initialize ()
{
	AddAttachment(new LScriptMenuAttachment);
}


// ---------------------------------------------------------------------------
//		 ~CAppearanceDemoApp
// ---------------------------------------------------------------------------
//	Destructor
//

CAppearanceDemoApp::~CAppearanceDemoApp()
{
	// nothing
}


// ---------------------------------------------------------------------------
//		 StartUp
// ---------------------------------------------------------------------------

void
CAppearanceDemoApp::StartUp()
{
	CommandT theCommand = cmd_New;
		
	open = nil;


	if (!UGraphicUtils::HasAppearance()) {
		theCommand = cmd_NewGrayWindow;
	}
	
	ObeyCommand(theCommand, nil);
	ObeyCommand(cmd_ToolBarWindow, nil);
}


// ---------------------------------------------------------------------------
//		 ObeyCommand
// ---------------------------------------------------------------------------
//	Respond to commands

Boolean
CAppearanceDemoApp::ObeyCommand(
	CommandT	inCommand,
	void*		ioParam)
{
	bool			cmdHandled = true;
	bool			usingAM = true;
	
	switch (inCommand) {
		case 3234:
			theMetalWindow = LWindow::CreateWindow(136, this);
			
			break;
		case 2134:
			save->Show ();			
			break;
		case 2135:
			if (!open)
				open = LWindow::CreateWindow(5004, this);
			else open->Show ();
			break;
		case 1234:
			if (theNormalSheet->IsVisible ())
				theNormalSheet->Hide ();
			else theNormalSheet->Show ();
			break;
		case cmd_ToolBarWindow:
			LWindow* theWindow = LWindow::CreateWindow(140, this);
			ThrowIfNil_(theWindow);
			
			UReanimator::LinkListenerToControls(this, theWindow, 140);
			
			theWindow->Show();
			
			theDrawer  = dynamic_cast <LWindowDrawer*>(LWindow::CreateWindow(130, this));				
			ThrowIfNil_(theDrawer);
			theDrawer->SetParent (theWindow);
			
			UReanimator::LinkListenerToControls(this, theDrawer, 130);
			
			theNormalSheet = dynamic_cast <LWindowSheet*>(LWindow::CreateWindow(135, this));
			ThrowIfNil_(theNormalSheet);
			theNormalSheet->SetParent (theWindow);
			
			UReanimator::LinkListenerToControls(this, theNormalSheet, 135);
			
			save = dynamic_cast <LWindowSheet*>(LWindow::CreateWindow(5000, this));
			ThrowIfNil_(save);
			save->SetParent (theWindow);
			
			UReanimator::LinkListenerToControls(this, save, 5000);

			break;

		case cmd_CopyURLToClipboard: {
			// This is for the contextual menu on the URLCaption in
			// the dialog.

				// Get the text string, put it on the scrap.
			
			LWindow*	theDialog = UDesktop::FetchTopModal();
			if (theDialog != nil) {
				CURLCaption* theCapt = dynamic_cast<CURLCaption*>
										(theDialog->FindPaneByID(item_DialogURLCaption));
				if (theCapt != nil) {
					LStr255	theURL;
					theCapt->GetDescriptor(theURL);

					UScrap::SetData(ResType_Text, theURL.TextPtr(), theURL.LongLength(), true);
				}
			}
			
			break;
		}

		case cmd_BeepTwice: {
			::SysBeep(3);
			// fall through
		}
		
		case cmd_Beep: {
			::SysBeep(3);
			break;
		}

		case cmd_NewFloatingWindow: {
			UControlRegistry::RegisterClasses(); // use whatever is "native"
			LWindow*	floatWindow = LWindow::CreateWindow(PPob_FloatingWindow, this);
			if (floatWindow) {
				floatWindow->Show();
			}
			break;
		}

			// We just switch to determine what implementation classes
			// to (re)register
		
		case cmd_New: {
			UControlRegistry::RegisterAMClasses();
			usingAM = true;
			break;
		}

		case cmd_NewGrayWindow: {
			UControlRegistry::RegisterGAClasses();
			usingAM = false;
			break;
		}


		case cmd_Dialog: {
			UControlRegistry::RegisterClasses(); // use whatever is "native"
	
			StDialogHandler	theHandler(PPob_Dialog, this);
			LWindow*		theDialog = theHandler.GetDialog();
			Assert_(theDialog != nil);
			
				// Get the main multi panel view and load up all the panels
			LMultiPanelView*	mainMPV = dynamic_cast<LMultiPanelView*>
										(theDialog->FindPaneByID(item_DialogMainPanelView));
			ThrowIfNil_(mainMPV);
			mainMPV->CreateAllPanels();
			
				// Get the Sundry panel
			LView*	sundryPanel = mainMPV->GetPanel(index_SundryPanel);
			ThrowIfNil_(sundryPanel);
			
				// Get it's MPV and page controller and have them
				// listen to each other
			LMultiPanelView*	sundryMPV = dynamic_cast<LMultiPanelView*>
										(sundryPanel->FindPaneByID(item_DialogSecondPanelView));
			ThrowIfNil_(sundryMPV);
			
			LPageController*	thePage = dynamic_cast<LPageController*>
										(sundryPanel->FindPaneByID(item_DialogPageController));
			ThrowIfNil_(thePage);
			
			thePage->AddListener(sundryMPV);

				// Add a contextual menu to the URLCaption
			
			CURLCaption*	urlCapt = dynamic_cast<CURLCaption*>
										(theDialog->FindPaneByID(item_DialogURLCaption));
			ThrowIfNil_(urlCapt);
			
				// Application object will serve as the CommandTarget
				// (and handler) for these needs. theDialog could be
				// a good handler as well.
			CCMURLAttachment*	urlCMAttach = new CCMURLAttachment(this);
			urlCapt->AddAttachment(urlCMAttach);
			
			theDialog->Show();
			
			MessageT theMessage;
			do {
				theMessage = theHandler.DoDialog();
			} while ( theMessage != msg_OK && theMessage != msg_Cancel );
			
		}
		break;

		default: {
			cmdHandled = LApplication::ObeyCommand(inCommand, ioParam);
			break;
		}
	}

	// if we have a command for us....(yea, this is long and ugly, but
	// hey, it's a demo)
	
	if (inCommand == cmd_New || inCommand == cmd_NewGrayWindow) {

		// create the window
		
		LWindow*	theWindow = LWindow::CreateWindow(PPob_DemoWindow, this);	
		
		if (theWindow != nil) {

			// link up all of the broadcasting widgets...
			
			// ...some widgets are true controls, so we can link
			// them in this way...
			
			UReanimator::LinkListenerToControls(this, theWindow, PPob_DemoWindow);
			
			// ...some are views that broadcast, so we have
			// to link them manually...
			
			LCheckBoxGroupBox*	theCheckGroup = dynamic_cast<LCheckBoxGroupBox*>
												(theWindow->FindPaneByID(item_CheckBoxGroupBox));
			if (theCheckGroup != nil) {
				theCheckGroup->AddListener(this);
			}
			
			LPopupGroupBox*		thePopGroup = dynamic_cast<LPopupGroupBox*>
											(theWindow->FindPaneByID(item_PopupGroupBox));
			if (thePopGroup != nil) {
				thePopGroup->AddListener(this);
			}
			
			LImageWell*	theWell = dynamic_cast<LImageWell*>
									(theWindow->FindPaneByID(item_ImageWell));
			if (theWell != nil) {
				theWell->AddListener(this);
			}
			
			LPictureControl*	thePicControl = dynamic_cast<LPictureControl*>
												(theWindow->FindPaneByID(item_PictureControl));
			if (thePicControl != nil) {
				thePicControl->AddListener(this);
			}
			
			// ... and so that we can pick up the broadcasts of the controls
			// in the "Buttons" popup group box (we'll just do the first panel. The
			// rest will be done in ListenToMessage() when we actually switch).

			LMultiPanelView*	thePanelView = dynamic_cast<LMultiPanelView*>
											(theWindow->FindPaneByID(item_MultiPanelView));
			
			if (thePanelView != nil) {
				
				thePanelView->SwitchToPanel(1);
				LView*	theCurView = thePanelView->GetCurrentPanel();
				if (theCurView) {
					UReanimator::LinkListenerToControls(this, theCurView, PPob_FirstMultiPanelView);
				}
			}
			
			// build procedural controls. We build these controls on the fly as
			// they are controls that work with Live Tracking. There isn't an
			// "easy" way to flip the live tracking switch on and off...we just
			// have to trash the old stuff and build a new one. Hence, we build
			// them always procedurally.
			
			BuildScrollerView(theWindow, true);
			
			LTextGroupBox*	theTextGroup = dynamic_cast<LTextGroupBox*>
											(theWindow->FindPaneByID(item_LiveGroupBox));
			if (theTextGroup != nil) {
				BuildLiveTrackers(theTextGroup, true);

				LCheckBox*	theTrackCheck = dynamic_cast<LCheckBox*>
											(theWindow->FindPaneByID(item_TrackingCheckBox));
				if (theTrackCheck != nil) {
					theTrackCheck->Enable();
					theTrackCheck->AddListener(this);
				}
			}
									
			// set up the "what are we running" caption
			
			LStaticText*	theHeaderText = dynamic_cast<LStaticText*>
								(theWindow->FindPaneByID(item_AMGACaption));
			
			if (theHeaderText != nil) {

				LStr255 headStr;
				
				if ( UEnvironment::HasFeature(env_HasAppearance) ) {
					headStr += StringLiteral_("Appearance Manager present.");
					
					if ( UEnvironment::HasFeature(env_HasAppearanceCompat) ) {
						headStr += StringLiteral_(" In Compatibility mode.");
					}
	
				} else {
					headStr += StringLiteral_("Appearance Manager NOT present.");
				}
			
				if ( usingAM ) {
					headStr += StringLiteral_(" Using AM implementations.");
				} else {
					headStr += StringLiteral_(" Using GA implementations.");
				}
				
				theHeaderText->SetDescriptor(headStr);
			}
			
			// give the window an appropriate title
			
			LStr255 title = usingAM ?
							str_AMWindowTitle :
							str_GAWindowTitle;
			
			theWindow->SetDescriptor(title);

			// show it
			
			theWindow->Show();
		}
	}
		
	return cmdHandled;
}


// ---------------------------------------------------------------------------
//		 FindCommandStatus
// ---------------------------------------------------------------------------

void
CAppearanceDemoApp::FindCommandStatus(
	CommandT	inCommand,
	Boolean&	outEnabled,
	Boolean&	outUsesMark,
	UInt16&		outMark,
	Str255		outName)
{
	Str255 title;
	
	switch (inCommand) {
		case 3234:
			outEnabled = true;
			break;
		case 2134:
			LString::CopyPStr(str_ToolBarWindowTitle, title);
			outEnabled = UGraphicUtils::HasAppearance() && UWindows::FindNamedWindow(title) ;
			break;
		case 2135:
			outEnabled = true;
			break;
		case 1234:
			LString::CopyPStr(str_ToolBarWindowTitle, title);
			outEnabled = UGraphicUtils::HasAppearance() && UWindows::FindNamedWindow(title) ;
			break;
		case cmd_New: {
			LString::CopyPStr(str_AMWindowTitle, title);
			outEnabled = UGraphicUtils::HasAppearance() &&
							!UWindows::FindNamedWindow(title);
			break;
		}
		
		case cmd_ToolBarWindow: {
			LString::CopyPStr(str_ToolBarWindowTitle, title);
			outEnabled = UGraphicUtils::HasAppearance() && !UWindows::FindNamedWindow(title);
			break;
		}
		
		case cmd_NewFloatingWindow:
		case cmd_Dialog:
		case cmd_Beep:
		case cmd_BeepTwice: {
			outEnabled = true;
			break;
		}
		
		case cmd_CopyURLToClipboard: {
			// This is for the contextual menu on the URLCaption in
			// the dialog.
			
			outEnabled = true;
			break;
		}
	
		default:
			LApplication::FindCommandStatus(inCommand, outEnabled,
												outUsesMark, outMark, outName);
			break;
	}
}


// ---------------------------------------------------------------------------
//		 UseIdleTime
// ---------------------------------------------------------------------------
//	Make our determinant progress bar actually do something.

void
CAppearanceDemoApp::UseIdleTime(
	const EventRecord&	inMacEvent )
{
	LApplication::UseIdleTime(inMacEvent);
	
	// small governor, just so the determinant progress bar
	// doesn't go too fast
	
	if ( mLastTick >= ::TickCount() )
		return;
	
	LWindow*	theWindow = UDesktop::FetchTopRegular();
	
	if (theWindow != nil) {
			
		LProgressBar*	theBar = dynamic_cast<LProgressBar*>(theWindow->FindPaneByID(item_DeterminantPBar));
		
		if (theBar != nil) {
		
			SInt32 value = theBar->GetValue();
			
			value += 1000;
			
			if (value > theBar->GetMaxValue())
				value = theBar->GetMinValue();
			
			theBar->SetValue(value);
		}
	}
	
	mLastTick = ::TickCount() + 5; // reset the governor
}


// ---------------------------------------------------------------------------
//		 ListenToMessage
// ---------------------------------------------------------------------------

void
CAppearanceDemoApp::ListenToMessage(
	MessageT		inMessage,
	void*			ioParam )
{
	LWindow*	theWindow = UDesktop::FetchTopRegular();
	if ( theWindow == nil )
		return;

	// display the broadcasted value message. We'll filter out the
	// determinant progress bar as since we're setting it's value
	// every time we idle, it gets awfully chatty.
	
	if ( (inMessage != msg_DeterminantPBar)  &&		// This gets sent while idling
		 (inMessage != msg_ControlClicked) ) {		// This is an internal message

		LStaticText*	theBroadcastCaption = dynamic_cast<LStaticText*>
											(theWindow->FindPaneByID(item_BroadcastValueCaption));

		if (theBroadcastCaption != nil) {

			// since almost all of the value messages in this demo are FourCharCodes,
			// let's display them as such as it looks better.
			
			LStr255 capt(inMessage);
			
			if ( inMessage >= 0x20202020 ) {
				capt = static_cast<FourCharCode>(inMessage);
				capt.Insert( char_Apostrophe, 1 );
				capt += char_Apostrophe;
			}
			
			theBroadcastCaption->SetDescriptor(capt);
		}
	}
	
	// make some noise
	
	if (inMessage != msg_DeterminantPBar
		&& inMessage != msg_LittleArrows
		&& inMessage != msg_ScrollBar
		&& inMessage != msg_Slider
		&& inMessage != msg_PopupButton
		&& inMessage != msg_DoTracking
		&& inMessage != msg_BroadcasterDied
		&& inMessage != msg_ControlClicked
		&& inMessage != msg_ThumbDragged
		&& inMessage != msg_ScrollAction )
	{
		::SysBeep(3);
	}
	
	
	switch (inMessage)
	{
		case 56:
			theDrawer->Toogle ();
			break;
		
		case msg_LittleArrows:
		{
			// give some sort of response to the little arrows tracking
			
			LStaticText*	theCaption = dynamic_cast<LStaticText*>
										(theWindow->FindPaneByID(item_TrackingCaption));
			
			if ( theCaption != nil ) {
				theCaption->SetValue(*(static_cast<SInt32*>(ioParam)));
				Rect frame;
				theCaption->FocusDraw();
				theCaption->CalcLocalFrameRect(frame);
				theCaption->ApplyForeAndBackColors();
				::EraseRect(&frame);
				theCaption->Draw(nil);
			}
			
			break;
		}

		case msg_Slider:
		{
			// give some sort of response to the slider tracking
			
			LStaticText*	theCaption = dynamic_cast<LStaticText*>
										(theWindow->FindPaneByID(item_TrackingCaption));
			
			if ( theCaption != nil ) {
				theCaption->SetValue(*(static_cast<SInt32*>(ioParam)));
				Rect frame;
				theCaption->FocusDraw();
				theCaption->CalcLocalFrameRect(frame);
				theCaption->ApplyForeAndBackColors();
				::EraseRect(&frame);
				theCaption->Draw(nil);
			}
			
			break;
		}
									
		case msg_ScrollBar:
		{
			// give some sort of response to the scroll bar tracking
			
			LStaticText*	theCaption = dynamic_cast<LStaticText*>
										(theWindow->FindPaneByID(item_TrackingCaption));
			
			if ( theCaption != nil ) {
				theCaption->SetValue(*(static_cast<SInt32*>(ioParam)));
				Rect frame;
				theCaption->FocusDraw();
				theCaption->CalcLocalFrameRect(frame);
				theCaption->ApplyForeAndBackColors();
				::EraseRect(&frame);
				theCaption->Draw(nil);
			}
			
			break;
		}
		
		case msg_DoTracking:
		{
			// Hooked up to the "Live Tracking" checkbox. Controls whether
			// or not the live tracking controls do live tracking or not.
			// We'll trash the existing controls and rebuild new versions
			// with the new setting of the checkbox.
			
			// make sure we're properly registered
			
			LWindow*	frontWindow = UDesktop::FetchTopRegular();
			Str255 temp;
			frontWindow->GetDescriptor(temp);
			LStr255 frontTitle(temp);
			if ( str_AMWindowTitle == frontTitle )
				UControlRegistry::RegisterClasses();
			else
				UControlRegistry::RegisterGAClasses();
			
			// scrap the scroller view...
			
			LScrollerView*	theScroller = dynamic_cast<LScrollerView*>
											(theWindow->FindPaneByID(item_ScrollerView));
			delete theScroller;
			
			// ...and build a new one on the fly
			
			BuildScrollerView(theWindow, *(static_cast<SInt32*>(ioParam)));

			// scrap the live trackers...
			
			LSlider*	theSlider = dynamic_cast<LSlider*>
									(theWindow->FindPaneByID(item_Slider));
			delete theSlider;
			
			LLittleArrows*	theArrows = dynamic_cast<LLittleArrows*>
										(theWindow->FindPaneByID(item_LittleArrows));
			delete theArrows;
			
			LScrollBar*	theBar = dynamic_cast<LScrollBar*>
									(theWindow->FindPaneByID(item_ScrollBar));
			delete theBar;
			
			LTextGroupBox*	theTextGroup = dynamic_cast<LTextGroupBox*>
											(theWindow->FindPaneByID(item_LiveGroupBox));
			
			// ...and build a new ones on the fly
			
			BuildLiveTrackers(theTextGroup, *(static_cast<SInt32*>(ioParam)));
			
			break;
		}
		
		case msg_PopupGroupBox:
		{
			// this is the "Buttons" popup group box
			
			LMultiPanelView*	thePanelView = dynamic_cast<LMultiPanelView*>
											(theWindow->FindPaneByID(item_MultiPanelView));
			
			if (thePanelView != nil) {
				
				LView*	theView = thePanelView->GetPanel( *(static_cast<SInt32*>(ioParam)));
				
				if (theView != nil) {
					UReanimator::LinkListenerToControls(this, theView,
													*(static_cast<SInt32*>(ioParam)) - 1 + 1000);
				}
			}
		
			break;
		}
		
		case msg_PopupButton:
		{
			// play the sound!
			
			// NB: There is a bug in Appearance 1.0 that will cause this to crash
			// (or somehow otherwise fail). Appearance 1.0 does not support the
			// getting of the MenuHandle from the popup button. Appearance 1.0.1/1.0.2
			// added this functionality.
			//
			// Since the GA imps do not have this problem, you should check the
			// Appearance version number (UEnvironment provides a means for this).
			// If Appearance 1.0 is installed (or Appearance isn't present at all),
			// then register the GA imp for LPopupButton (and potentially any other
			// menu-using widgets like LPopupGroupBox and LBevelButton). If you
			// have at least Appearance 1.0.1, thn you should be able to safely
			// use the AM imp.
			
			LPopupButton*	thePopup = dynamic_cast<LPopupButton*>
										(theWindow->FindPaneByID(item_PopupButton));
			if (thePopup != nil) {
			
				Str255 soundName;
				::GetMenuItemText(thePopup->GetMacMenuH(),
									*(static_cast<SInt32*>(ioParam)),
									soundName);
				
				StResource soundH(FOUR_CHAR_CODE('snd '), soundName, false, false);
				
				if ( soundH.IsValid() ) {
					StHandleLocker lock(soundH);
					::SndPlay(nil, (SndListHandle)((Handle)soundH), false);
				}
			}
			
			break;
		}
		
		
		case msg_DisclosureTriangle:
		{
			// we'll expand/collapse the window accordingly
			
			Rect windBounds;
			theWindow->GetGlobalBounds(windBounds);
			
			if ( *(static_cast<SInt32*>(ioParam)) == 1 ) {
				windBounds.bottom += kDiscloseAmount;	// expanding
			} else {
				windBounds.bottom -= kDiscloseAmount;	// collapsing
			}
			
			theWindow->DoSetBounds(windBounds);
		
			break;
		}
	}

}


// ---------------------------------------------------------------------------
//		 BuildScrollerView
// ---------------------------------------------------------------------------
//	Builds our LScrollerView. Assumes the existing LScrollerView has already
//	been deleted.

void
CAppearanceDemoApp::BuildScrollerView(
	LView*	inContainer,
	bool	inDoTracking )
{
	if (inContainer == nil) {
		SignalStringLiteral_("Scroller container is nil");
		return;
	}
	
	SPaneInfo	paneInfo = {	item_ScrollerView,
								308,
								184,
								true,
								true,
								{false, false, false, false},
								280,
								208,
								0,
								inContainer };
								
	SViewInfo	viewInfo = {	{1, 1},
								{0 ,0},
								{0, 0},
								false };	// defaults taken from LScrollerView CTYP
								
	SInt16		leftIndent		= 0;
	SInt16		rightIndent		= 15;
	SInt16		topIndent		= 0;
	SInt16		bottomIndent	= 15;
	
	// create the view that is scrolled
	
	LView*	theScrollView = UReanimator::CreateView(PPob_ScrollingView, inContainer, this);
	ThrowIfNil_(theScrollView);
	
	// create the LScrollerView
	
	LScrollerView*	theScroller = new LScrollerView(	paneInfo,
														viewInfo,
														leftIndent,
														rightIndent,
														topIndent,
														bottomIndent,
														16, // it's of "normal" thickness
														theScrollView,
														inDoTracking );

	theScroller->FinishCreate();
	
	// and tweak a few things
	theScrollView->PutInside(theScroller);
	theScrollView->PlaceInSuperFrameAt(2, 2, Refresh_Yes);
	
	inContainer->Refresh();
}


// ---------------------------------------------------------------------------
//		 BuildLiveTrackers
// ---------------------------------------------------------------------------
//	Builds our suite of live tracking controls. Assumes the old versions
//	of the controls have already been deleted.

void
CAppearanceDemoApp::BuildLiveTrackers(
	LView*	inContainer,
	bool	inDoTracking )
{
	if (inContainer == nil) {
		SignalStringLiteral_("Tracker container is nil");
		return;
	}
	
	// Build the Slider
	
	SPaneInfo paneInfo = { item_Slider,
								124,
								20,
								true,
								true,
								{false, false, false, false},
								12,
								60,
								0,
								inContainer };
	MessageT		valueMsg		= msg_Slider;
	SInt32			val				= 1;
	SInt32			minVal			= 1;
	SInt32			maxVal			= 100;
	bool			nonDirect		= false;
	bool			reverseDir		= false;
	bool			hasTicks		= true;
	SInt16			numTicks		= 10;
	
	LSlider*	theSlider = new LSlider(	paneInfo,
											valueMsg,
											val,
											minVal,
											maxVal,
											inDoTracking,
											nonDirect,
											reverseDir,
											hasTicks,
											numTicks );
	theSlider->FinishCreate();
	theSlider->AddListener(this);
	
	// Build the Little Arrows
	
	// technically little arrows always track (else, what's the point?)
	// but we'll just be complete and rebuild it anyways.

	paneInfo.paneID = item_LittleArrows;
	paneInfo.width  = 13;
	paneInfo.height = 23;
	paneInfo.left   = 12;
	paneInfo.top    = 28;
	
	valueMsg = msg_LittleArrows;
	val		 = 1;
	minVal   = 1;
	maxVal   = 100;
	
	LLittleArrows*	theArrows = new LLittleArrows(	paneInfo,
													valueMsg,
													val,
													minVal,
													maxVal ); 
	theArrows->FinishCreate();
	theArrows->AddListener(this);
	
	paneInfo.paneID = item_ScrollBar;
	paneInfo.width  = 124;
	paneInfo.height = 16;
	paneInfo.left   = 12;
	paneInfo.top    = 92;
	
	valueMsg = msg_ScrollBar;
	val		 = 1;
	minVal   = 1;
	maxVal   = 100;

	// Build the Scroll Bar
		
	LScrollBar*	theBar = new LScrollBar(paneInfo,
										valueMsg,
										val,
										minVal,
										maxVal,
										inDoTracking );
	theBar->FinishCreate();
	theBar->AddListener(this);
	
	inContainer->Refresh();
}

