// ===========================================================================
//	CAppearanceDemoApp.h	1997-2002 Metrowerks Corporation.  All rights reserved.
// ===========================================================================
//	Original Author: John C. Daub

#pragma once

#include <LApplication.h>
#include <LListener.h>
#include <LView.h>
#include <LWindowDrawer.h>
#include <LWindowSheet.h>

class	CAppearanceDemoApp : public LApplication,
							 public LListener {
public:
							CAppearanceDemoApp();

	virtual					~CAppearanceDemoApp();

	virtual Boolean			ObeyCommand(
									CommandT			inCommand,
									void*				ioParam);	

	virtual void			FindCommandStatus(
									CommandT			inCommand,
									Boolean&			outEnabled,
									Boolean&			outUsesMark,
									UInt16&				outMark,
									Str255				outName);

	virtual void			UseIdleTime(
									const EventRecord&	inMacEvent);

protected:
			UInt32			mLastTick;

	virtual void			StartUp();
	
	virtual	void			ListenToMessage(
									MessageT			inMessage,
									void*				ioParam);

	virtual	void			BuildScrollerView(
									LView*				inContainer,
									bool				inDoTracking);
									
	virtual	void			BuildLiveTrackers(
									LView*				inContainer,
									bool				inDoTracking);
									
	virtual void    Initialize ();
									
	LWindowDrawer *theDrawer;
	LWindowSheet *theNormalSheet;
	LWindow* theMetalWindow;
	LWindow *open;
	LWindowSheet *save;
};
