// ===========================================================================
//	CURLCaption.cp		1999-2002 Metrowerks Corporation.  All rights reserved.
// ===========================================================================
//	Original Author: John C. Daub
//
//	This is a VERY simple class designed solely to help demonstrate
//	using LCMAttachment objects on non-Commander Pane objects. A more
//	useful URL-caption/button class is CURLPushButton, a contributed
//	PowerPlant class. Or if you prefer an Attachment, HURLAttachment
//	can work (both classes written by John C. Daub).
//
//	For the demonstration purposes, the Application object will be
//	the CommandTarget for the CURLButton's LCMAttachment. The Application
//	object will merely Beep/Signal in response... a real app would
//	probably use something like Internet Config to dispatch the
//	URL (CURLPushButton and HURLAttachment do this).

#ifdef PowerPlant_PCH
	#include PowerPlant_PCH
#endif

#include "CURLCaption.h"

#include <LString.h>


CURLCaption::CURLCaption(
	LStream*	inStream)

	: LStaticText(inStream)
{
}

CURLCaption::~CURLCaption()
{
}


void
CURLCaption::GetSelection(
	AEDesc&		outDesc) const
{
	LStr255	theURL;
	GetDescriptor(theURL);
	
	OSErr err = ::AECreateDesc(	typeChar,
								theURL.TextPtr(),
								theURL.LongLength(),
								&outDesc);
	ThrowIfOSErr_(err);
}