// ===========================================================================
//	LOneTimeTask.h		1999-2002 Metrowerks Corporation.  All rights reserved.
// ===========================================================================
//	Original author: John C. Daub. Thanx to Rick Aurbach for the idea.

#ifndef _H_LOneTimeTask
#define _H_LOneTimeTask
#pragma once

#include <LPeriodical.h>

#if PP_Uses_Pragma_Import
	#pragma import on
#endif

PP_Begin_Namespace_PowerPlant

enum EPeriodicTaskType {
	periodicTaskType_Repeat			=	0,
	periodicTaskType_Idle			=	1
};

class LOneTimeTask : public LPeriodical {

public:

							LOneTimeTask(
									EPeriodicTaskType	inTaskType = periodicTaskType_Repeat);
	virtual					~LOneTimeTask();
	
	virtual	void			SpendTime(
									const EventRecord&	inMacEvent);

protected:
			bool			mActive;
	
	virtual	void			Perform() = 0;
	
private:

							LOneTimeTask(const LOneTimeTask& inOriginal);
			LOneTimeTask&	operator=(const LOneTimeTask& inRhs);
};


PP_End_Namespace_PowerPlant

#if PP_Uses_Pragma_Import
	#pragma import reset
#endif

#endif // _H_LOneTimeTask
